#include "stdafx.h"
#include "ModelViewerRenderer.h"


CModelViewerRenderer::CModelViewerRenderer() :
	m_bRotation(true),
	m_bPan(true),
	m_bZoom(true),
	m_bRenderPoint(true),
	m_bRenderLine(true),
	m_bRenderFace(true),
	m_bPickPoint(true),
	m_bPickLine(true),
	m_bPickFace(true)
{
	MakeArray();
}


CModelViewerRenderer::~CModelViewerRenderer()
{
	DestroyArray();
}

bool CModelViewerRenderer::DoTracking( POINT point )
{
	if( (TM_ROTATION == m_eTrackingMode && !m_bRotation)
	 || (TM_PAN == m_eTrackingMode && !m_bPan)
	 || (TM_ZOOM == m_eTrackingMode && !m_bZoom) )
	{       // ȃ}EXΉ
		return false;
	}

	// eNX̊֐̌Ăяo
	return COpenGLRendererPick::DoTracking( point );
}

void CModelViewerRenderer::RenderModel( ERENDERMODE eRenderMode )
{
	if( 0 == m_model.m_vVertex.size() )
	{
		return;
	}

	unsigned int uiIndexTriangle;
	unsigned int uiIndexLine;
	unsigned int uiIndexPoint;
	unsigned int ui3;

	glPushAttrib( GL_ALL_ATTRIB_BITS );	// Agr[gAł悤ɁAǉ

	// _z̗L
	glEnableClientState( GL_VERTEX_ARRAY );

	// _z̎w
	glVertexPointer( 3, GL_FLOAT, 0, m_model.m_afTriangleVertex );

	// 
	if( m_bRenderFace )
	{
		if( RM_PICK_ELEMENTID == eRenderMode )
		{
			glEnableClientState( GL_COLOR_ARRAY );
			glColorPointer( 4, // Must be 4.
				GL_UNSIGNED_BYTE,
				0,
				m_abt4TriangleIdColor );
		}
		else if( RM_PICK_ELEMENTTYPE == eRenderMode )
		{
			glColor3f( 1.0f, 0.0f, 0.0f );
		}
		else //if( RM_RENDER == eRenderMode )
		{
			glColor3f( 0.5f, 0.5f, 0.0f );
		}
		glDrawArrays( GL_TRIANGLES, 0, m_model.m_vIndexedTriangle.size() * 3 );
		glDisableClientState( GL_COLOR_ARRAY );
		// sbNʂ̕`
		if( RM_RENDER == eRenderMode )
		{
			if( RET_FACE == m_auiName_picked[1] )
			{
				uiIndexTriangle = m_auiName_picked[2];
				glColor3f( 1.0f, 1.0f, 0.0f );	// sbNF
				glDrawArrays( GL_TRIANGLES, uiIndexTriangle * 3, 3 );
			}
		}
	}
	// 
	if( m_bRenderLine )
	{
		glLineWidth( 2.0 );
		if( RM_PICK_ELEMENTID == eRenderMode )
		{
			for( uiIndexTriangle = 0; uiIndexTriangle < m_model.m_vIndexedTriangle.size(); uiIndexTriangle++ )
			{
				for( ui3 = 0; ui3 < 3; ui3++ )
				{
					uiIndexLine = uiIndexTriangle * 3 + ui3;
					glColor3ub( GetRValue(uiIndexLine), GetGValue(uiIndexLine), GetBValue(uiIndexLine) );
					glDrawElements( GL_LINES,
						2,
						GL_UNSIGNED_INT,
						&m_model.m_auiEdgeVertexIndex[2 * uiIndexLine] );
				}
			}
		}
		else
		{
			if( RM_PICK_ELEMENTTYPE == eRenderMode )
			{
				glColor3f( 0.0f, 1.0f, 0.0f );
			}
			else // if( RM_RENDER == eRenderMode )
			{
				glColor3f( 0.0f, 0.5f, 0.5f );
			}
			glDrawElements( GL_LINES,
				m_model.m_vIndexedTriangle.size() * 3 * 2,
				GL_UNSIGNED_INT,
				&m_model.m_auiEdgeVertexIndex[0] );
		}
		// sbN̕`
		if( RM_RENDER == eRenderMode )
		{
			if( RET_LINE == m_auiName_picked[1] )
			{
				uiIndexLine = m_auiName_picked[2];
				glLineWidth( 5.0f );
				glColor3f( 0.0f, 1.0f, 1.0f );
				glDrawElements( GL_LINES,
					2,
					GL_UNSIGNED_INT,
					&m_model.m_auiEdgeVertexIndex[2 * uiIndexLine] );
			}
		}
	}
	// _
	if( m_bRenderPoint )
	{
		glPointSize( 5.0 );
		if( RM_PICK_ELEMENTID == eRenderMode )
		{
			glEnableClientState( GL_COLOR_ARRAY );
			glColorPointer( 4, // Must be 4.
				GL_UNSIGNED_BYTE,
				0,
				m_abt4VertexIdColor );
		}
		else if( RM_PICK_ELEMENTTYPE == eRenderMode )
		{
			glColor3f( 0.0f, 0.0f, 1.0f );
		}
		else //if( RM_RENDER == eRenderMode )
		{
			glColor3f( 0.5f, 0.0f, 0.5f );
		}
		glDrawArrays( GL_POINTS, 0, m_model.m_vIndexedTriangle.size() * 3 );
		glDisableClientState( GL_COLOR_ARRAY );
		// sbN_̕`
		if( RM_RENDER == eRenderMode )
		{
			if( RET_POINT == m_auiName_picked[1] )
			{
				uiIndexPoint = m_auiName_picked[2];
				glPointSize( 10.0f );
				glColor3f( 1.0f, 0.0f, 1.0f );
				glDrawArrays( GL_POINTS, uiIndexPoint, 1 );
			}
		}
	}

	// _z̖
	glDisableClientState( GL_VERTEX_ARRAY );

	glPopAttrib();	// Agr[g̕A
	return;
}

void CModelViewerRenderer::IdentifyPickRegionPixels( unsigned int uiCountPickRegionPixel, unsigned int aauiNamePickRegionPixel[][NAMEARRAYSIZE] )
{
	int  iId_selected = -1;
	unsigned int  uiElementType_selected = RET_FACE + 1;
	long lSquareDist_selected = ( 2 + PICKREGIONOFFSET ) * ( 2 + PICKREGIONOFFSET ) + ( 2 + PICKREGIONOFFSET ) * ( 2 + PICKREGIONOFFSET );
	long lSquareDist_current;
	int  x;
	int  y;
	for( unsigned int ui = 0; ui < uiCountPickRegionPixel; ui++ )
	{
		if( 0 == aauiNamePickRegionPixel[ui][1] )
		{ // f̊O
			continue;
		}

		if( !m_bPickPoint && RET_POINT == aauiNamePickRegionPixel[ui][1] )
		{	// _sbNOFF̏ꍇ́A_̓sbNłȂ
			continue;
		}
		if( !m_bPickLine && RET_LINE == aauiNamePickRegionPixel[ui][1] )
		{	// sbNOFF̏ꍇ́A̓sbNłȂ
			continue;
		}
		if( !m_bPickFace && RET_FACE == aauiNamePickRegionPixel[ui][1] )
		{	// ʃsbNOFF̏ꍇ́Aʂ̓sbNłȂ
			continue;
		}

		if( uiElementType_selected < aauiNamePickRegionPixel[ui][1] )
		{ // vf^CvIɁAD揇ʂႢ
			continue;
		}
		if( uiElementType_selected > aauiNamePickRegionPixel[ui][1] )
		{ // vf^CvIɁAD揇ʂႢ
			iId_selected = ui;
			uiElementType_selected = aauiNamePickRegionPixel[ui][1];
			x = ui % ( 1 + 2 * PICKREGIONOFFSET ) - PICKREGIONOFFSET;
			y = ui / ( 1 + 2 * PICKREGIONOFFSET ) - PICKREGIONOFFSET;
			lSquareDist_selected = x * x + y * y;
			continue;
		}
		// vf^CvIɁAD揇ʂꍇ́AsbN̈̒Sɋ߂̂DxB
		x = ui % ( 1 + 2 * PICKREGIONOFFSET ) - PICKREGIONOFFSET;
		y = ui / ( 1 + 2 * PICKREGIONOFFSET ) - PICKREGIONOFFSET;
		lSquareDist_current = x * x + y * y;
		if( lSquareDist_selected > lSquareDist_current )
		{
			iId_selected = ui;
			uiElementType_selected = aauiNamePickRegionPixel[ui][1];
			lSquareDist_selected = lSquareDist_current;
			continue;
		}
	}

	if( -1 == iId_selected )
	{
		return;
	}

	// O񃁃o̍XV
	memcpy( m_auiName_picked, aauiNamePickRegionPixel[iId_selected], NAMEARRAYSIZE * sizeof( unsigned int) );
}

void CModelViewerRenderer::MakeArray()
{
	unsigned int uiMaxColor = 256 * 256 * 256;	// 256*256*256=16,777,216Bunsigned int ̍ől(4,294,967,295)ɑ΂ė]TB

	// _ԍFz
	unsigned int uiCountData = uiMaxColor * 4;	// P_RGBÂSlB
	m_abt4VertexIdColor = new GLubyte[uiCountData];
	for( unsigned int ui = 0; ui < uiMaxColor; ui++ )
	{
		m_abt4VertexIdColor[ui * 4 + 0] = GetRValue( ui );
		m_abt4VertexIdColor[ui * 4 + 1] = GetGValue( ui );
		m_abt4VertexIdColor[ui * 4 + 2] = GetBValue( ui );
		m_abt4VertexIdColor[ui * 4 + 3] = (GLubyte)255;
	}

	// Op`ԍFz
	uiCountData = uiMaxColor * 3 * 4;	// P̎Op`́ARWlBP_RGBÂSlB
	m_abt4TriangleIdColor = new GLubyte[uiCountData];
	for( unsigned int ui = 0; ui < uiMaxColor; ui++ )
	{
		GLubyte r = GetRValue( ui );
		GLubyte g = GetGValue( ui );
		GLubyte b = GetBValue( ui );
		m_abt4TriangleIdColor[ui * 12 + 0] = r;
		m_abt4TriangleIdColor[ui * 12 + 1] = g;
		m_abt4TriangleIdColor[ui * 12 + 2] = b;
		m_abt4TriangleIdColor[ui * 12 + 3] = (GLubyte)255;
		m_abt4TriangleIdColor[ui * 12 + 4] = r;
		m_abt4TriangleIdColor[ui * 12 + 5] = g;
		m_abt4TriangleIdColor[ui * 12 + 6] = b;
		m_abt4TriangleIdColor[ui * 12 + 7] = (GLubyte)255;
		m_abt4TriangleIdColor[ui * 12 + 8] = r;
		m_abt4TriangleIdColor[ui * 12 + 9] = g;
		m_abt4TriangleIdColor[ui * 12 + 10] = b;
		m_abt4TriangleIdColor[ui * 12 + 11] = (GLubyte)255;
	}
}

void CModelViewerRenderer::DestroyArray()
{
	delete m_abt4VertexIdColor;
	delete m_abt4TriangleIdColor;
}
